
<script setup>
import {ref, computed, onMounted} from 'vue';
import {useTodoStore} from "@/stores/toDoListStore.js";
import router from "@/router/index.js";

const todoStore = useTodoStore();
const todos = computed(() => todoStore.todos);
const editedTodo = ref('');
const editedStatus = ref('');
const editedDescription = ref('');
const editDialog = ref(false);
let editedTodoIndex = null;

const deleteTodo = async (index) => {
  await todoStore.deleteTodoOnBackend(index);
};

const openEditDialog = (todo) => {
  editedTodoIndex = todos.value.findIndex(t => t === todo);
  editedTodo.value = todo.title;
  editedStatus.value = todo.status;
  editedDescription.value = todo.description;
  editDialog.value = true;
};

const closeEditDialog = () => {
  editDialog.value = false;
};

const saveEditedTodo = async () => {
  if (editedTodoIndex !== null) {
    await todoStore.editTodoOnBackend(editedTodoIndex, editedTodo.value, editedDescription.value, editedStatus.value);
    editDialog.value = false;
    editedTodo.value = '';
    editedDescription.value = '';
  }
};

const toggleTodoStatus = async (todo, newStatus) => {
  try {
    await todoStore.updateTodoStatusOnBackend(todo.taskId, newStatus);
  } catch (error) {
    console.error('Error toggling todo status:', error);
  }
};

const displayStatus = (status) => {
  switch (status) {
    case 'TODO':
      return 'Not Started';
    case 'IN_PROGRESS':
      return 'Work in Progress'; // Custom text for IN_PROGRESS
    case 'DONE':
      return 'Completed'; // Custom text for DONE
    default:
      return status; // Fallback to the original status if none of the above
  }
};

onMounted(async () => {
  try {
    await todoStore.fetchUserTodos();
  } catch (error) {
    if (error.response && error.response.status === 401) {
      router.push('/login');
    }
  }
});


const completedTasks = computed(() => todos.value.filter(t => t.status === 'DONE').length);
const remainingTasks = computed(() => todos.value.length - completedTasks.value);
const progress = computed(() => (todos.value.length > 0 ? (completedTasks.value / todos.value.length) * 100 : 0));
</script>

<template>
  <v-container>
    <h2 class="text-h5 text-success my-4">
      Tasks:&nbsp;
      <v-fade-transition leave-absolute>
        <span :key="`tasks-${todos.length}`">
          {{ todos.length }}
        </span>
      </v-fade-transition>
    </h2>


    <v-row class="my-2" align="center">
      <strong class="mx-4 text-info darken-2">
        Remaining: {{ remainingTasks }}
      </strong>

      <v-divider vertical></v-divider>

      <strong class="mx-4 text-success darken-2">
        Completed: {{ completedTasks }}
      </strong>

      <v-spacer></v-spacer>

      <!-- Progress Indicator -->
      <v-progress-circular
          v-model="progress"
          class="me-2"
          color="primary"
          size="50"
          width="10"
      ></v-progress-circular>

    </v-row>

    <v-row>
      <v-col cols="12">
        <div class="todo-list-container">
          <div v-if="todos.length > 0">
            <div v-for="(todo, index) in todos" :key="index" :class="{ 'completed': todo.completed }" class="todo-item" :data-status="todo.status">
              <div class="todo-content">
                <h3 :class="{'text-decoration-line-through': todo.status === 'DONE'}">{{ todo.title }}</h3>
                <p class="todo-status"><strong>Status:</strong> {{ displayStatus(todo.status) }}</p>
                <p class="todo-description"><strong>Description:</strong> {{ todo.description }}</p>
              </div>
              <div class="todo-actions">
                <v-btn class="status-btn set-todo-btn" @click="toggleTodoStatus(todo, 'TODO')">To Do</v-btn>
                <v-btn class="status-btn set-in-progress-btn" @click="toggleTodoStatus(todo, 'IN_PROGRESS')">In Progress</v-btn>
                <v-btn class="status-btn set-done-btn" @click="toggleTodoStatus(todo, 'DONE')">Done</v-btn>
              </div>
              <div class="todo-actions-delete-edit">
                <v-btn class="edit-btn" @click="openEditDialog(todo)">Edit</v-btn>
                <v-btn class="delete-btn" @click="deleteTodo(index)">Delete</v-btn></div>
            </div>
          </div>
          <v-alert v-else :value="true" color="info">No todos yet.</v-alert>
        </div>

        <!-- Edit Dialog -->
        <v-dialog v-model="editDialog" max-width="400">
          <v-card>
            <v-card-title>Edit Todo</v-card-title>
            <v-card-text>
              <v-text-field v-model="editedTodo" label="Edit Todo"></v-text-field>
              <v-text-field v-model="editedDescription" label="Edit Todo Description"></v-text-field>
            </v-card-text>
            <v-card-actions>
              <v-btn @click="closeEditDialog">Cancel</v-btn>
              <v-btn @click="saveEditedTodo" color="primary">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>
    </v-row>
  </v-container>
</template>


<style scoped>
.todo-list-container {
  border: none;
  padding: 20px;
  background-color: #f9f9f9;
  max-height: 500px; /* Adjust this value based on your needs */
  overflow-y: auto;
}

.todo-item {
  border-left: 5px solid; /* Color will be set dynamically */
  background-color: white;
  box-shadow: 0 2px 4px rgba(0,0,0,0.1);
  margin-bottom: 20px;
  padding: 15px;
  border-radius: 4px;
}

.todo-item.completed {
  background-color: #eaeaea;
}

.todo-content h3 {
  color: #333;
}

.todo-status {
  font-size: 0.9em;
  margin-bottom: 5px;
}

.todo-description {
  font-size: 0.9em;
  color: #666;
  margin-bottom: 10px;
}

.todo-actions v-btn {
  margin-right: 5px;
}

/* Specific color for each status */
.todo-item[data-status="TODO"] {
  border-left-color: #ff9800; /* Orange */
}

.todo-item[data-status="IN_PROGRESS"] {
  border-left-color: #2196f3; /* Blue */
}

.todo-item[data-status="DONE"] {
  border-left-color: #4caf50; /* Green */
}

.todo-actions v-btn {
  margin-right: 8px; /* Adjust spacing to the right of each button */
  min-width: 100px; /* Ensure buttons have a consistent width */
  text-transform: none; /* Prevents uppercase transformation */
  font-size: 14px; /* Standard font size for readability */
}

/* Optionally, if you need more specific styling */
.todo-actions {
  display: flex;
  flex-wrap: wrap; /* Allow buttons to wrap if needed */
  gap: 12px; /* Increase gap for better spacing */
  justify-content: flex-start; /* Align buttons to the start */
  padding-top: 10px;
}

.todo-actions-delete-edit{
  display: flex;
  flex-wrap: wrap;
  gap: 12px;
  justify-content: flex-end;
  padding-top: 10px;
}
/* Style for Edit and Delete buttons */
.todo-actions .edit-btn, .todo-actions .delete-btn {
  color: white; /* Text color */
  padding: 4px 8px; /* Smaller padding */
  font-size: 0.875rem;
}

.edit-btn {
  background-color: #E0E0E0; /* Blue for edit */
}

.delete-btn {
  background-color: #E57373; /* Red for delete */
}

/* Adjusting styles for status buttons */
.todo-actions .status-btn {
  color: #fff; /* White text for readability */
  padding: 6px 12px; /* Slightly larger padding for a better touch area */
  font-size: 0.9375rem;
}

/* Specific colors for status buttons */
.set-todo-btn {
  background-color: #ff9800; /* Orange */
}

.set-in-progress-btn {
  background-color: #2196f3; /* Blue */
}

.set-done-btn {
  background-color: #4caf50; /* Green */
}

.todo-content h3.text-decoration-line-through {
  color: #999; /* Dim the color for completed tasks */
  font-weight: bold; /* Make the text bolder to emphasize the line-through */

}
h3{
  font-size: 30px;
}
</style>
